Subject: Re: powerpc/perf: hw breakpoints return ENOSPC

From: Peter Zijlstra <[email-masked]>
Date: Thu, 16 Aug 2012 09:40:12 +0200

On Thu, 2012-08-16 at 14:23 +1000, Michael Neuling wrote:
>=20
> On this second syscall, fetch_bp_busy_slots() sets slots.pinned to be 1,
> despite there being no breakpoint on this CPU.  This is because the call
> the task_bp_pinned, checks all CPUs, rather than just the current CPU.
> POWER7 only has one hardware breakpoint per CPU (ie. HBP_NUM=3D1), so we
> return ENOSPC.

I think this comes from the ptrace legacy, we register a breakpoint on
all cpus because when we migrate a task it cannot fail to migrate the
breakpoint.

Its one of the things I hate most about the hwbp stuff as it relates to
perf.

Frederic knows more...